SystemOrganization addCategory: #ConfigurationOfExample!

Object subclass: #ConfigurationOfExample
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfExample'!

!ConfigurationOfExample class methodsFor: 'development support' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfExample class methodsFor: 'private' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfExample class methodsFor: 'private' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfExample class methodsFor: 'private' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfExample class methodsFor: 'metacello tool support' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfExample class methodsFor: 'loading' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfExample class methodsFor: 'loading' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfExample class methodsFor: 'loading' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfExample class methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
project

	^self new project! !

!ConfigurationOfExample class methodsFor: 'development support' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfExample methodsFor: 'baselines' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/VersionnerCacheTest'.
		spec 
			package: 'Example-C1';
			package: 'Example-C2'.
		spec group: 'default' with: #('Example-C1' 'Example-C2' ). ].
! !

!ConfigurationOfExample methodsFor: 'symbolic versions' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '1.0'.
! !

!ConfigurationOfExample methodsFor: 'accessing' stamp: 'JuanPabloSandovalA 6/13/2012 16:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfExample methodsFor: 'versions' stamp: 'JuanPabloSandovalA 6/13/2012 16:12'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '1.0 : agregando metodo 2 en clase 2'.
		spec author: 'JuanPabloSandovalA'.
		spec timestamp: '6/13/2012 16:12'.
		spec 
			package: 'Example-C1' with: 'Example-C1-JuanPabloSandovalA.1';
			package: 'Example-C2' with: 'Example-C2-JuanPabloSandovalA.2'. ].
! !
